/*
 * Created on 20.07.2005
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package hpp_generator;

import java.io.FileWriter;

/**
 * @author uid13999
 *
 * TODO To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
public class CHppGenerator {

    private static String evaluatePattern (String pattern, String token, int i)
    {
        return pattern.replaceAll(token, ""+i);
    }
    
    /*!
         \c list() creates out of a pattern a list of this pattern.
         \par n         the number of times, the pattern is repeated.
         \par pattern   the pattern that is repeated n times.
                        The substring \c token (typically "1") within this
                        pattern is treated in a special way and replaced by
                        the current number of repetition (beginning with
                        "1" and ending with n).   
         \par zero      the string written for the case n==0. Defaults to "".
         \par nonzero   This string is written before the repetition of
                        patterns, if n!=0. Defaults to "".
         \par token     The special character (or character sequence),
                        defaults to "1", that is replaced within the pattern.
         
         Example:
             list(3, "par1", ", ") generates "par1, par2, par3".
             list(0, "par1", ", ") generates "".
             list(3, "type1 par1", ", ", "void") generates "type1 par1, type2 par2, type3 par3".
             list(0, "type1 par1", ", ", "void") generates "void".

        \note At the moment there is no way provided (like quoting)
        to prevent the replacing of the character "1" in the pattern.
        
        \note \c nozero is used for prefixes. When you need postfixes
        for n!=0, program them outside of this function where you are
        calling it. In the typical case, when this postfix is identical
        to the delimiter, just move the delimiter to the repeated pattern.
    */

    public static String list (int n, String pattern, String delimiter, String zero, String nonzero, String token)
    {
        if (n == 0)
        {
            return zero;
        }
        String result = nonzero;
        for (int i = 1; i <= n; i++)
        {
            result += evaluatePattern(pattern, token, i);
            if (i < n)
            {
                result += delimiter;
            }
        }
        return result;
    }

    /*!
        See list().
    */
    public static String list (int n, String pattern, String delimiter, String zero, String nonzero)
    {
        return list (n, pattern, delimiter, zero, nonzero, "1");
    }

    /*!
        See list().
    */
    public static String list (int n, String pattern, String delimiter, String zero)
    {
        return list (n, pattern, delimiter, zero, "", "1");
    }

    /*!
         See list().
    */
    public static String list (int n, String pattern, String delimiter)
    {
        return list (n, pattern, delimiter, "", "", "1");
    }

    /*!
         See list().
    */
    public static String list (int n, String pattern)
    {
        return list (n, pattern, "", "", "", "1");
    }

    public String generate(Object argument)
    {
        return "";
    }

    public String namespace;
    public String classname;
    public String filename;
    public String extension = "hpp";
    public String author;
    public String includeguard;
    public final int maximalNumberOfParameters = 9;
    
    public void process()
    {
        String outputname = "<not yet initialized>";
        try
        {
            String s = generate(null);
            outputname = filename + "." + extension;
            FileWriter fw = new FileWriter(outputname);
            fw.write(s);
            fw.close();
        }
        catch (Throwable e)
        {
            System.err.println ("Could not write output file '" + outputname + "'. Exception '" + e + "'! Cause '" + e.getCause() + "'.");
            throw new Error("Could not write output file '" + outputname + "'.", e);
            // System.exit (1);
        }
        System.out.println ("File '" + outputname + "' written successfully.");
    }
}
