/**
    \file CThread.hpp
    \author Kurt Stege

    Thread Abstraction

    History:

    (ks) = Kurt Stege, kurt-stege@online.de

    2005-08-23 (ks):    File created.
    2005-08-23 (ks):    Current version.
*/

#ifndef NBase_CThread_hpp_INCLUDEGUARD
#define NBase_CThread_hpp_INCLUDEGUARD


namespace NBase {

/*!
    CThread is a Sigslot component that implements a thread.
*/
class CThread
{
    public:

    typedef void tFunction (void *);

    static void createThread (tFunction *func, void *par);
    static void sleep (long milliseconds);
};

} // namespace NBase

#endif // NBase_CThread_hpp_INCLUDEGUARD

